## ceres-solver 2.1.0%2Breally2.1.0%2Bdfsg

=== CMakeLists.txt ===
# Ceres Solver - A fast non-linear least squares minimizer
# Copyright 2022 Google Inc. All rights reserved.
# http://ceres-solver.org/
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright notice,
#   this list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright notice,
#   this list of conditions and the following disclaimer in the documentation
#   and/or other materials provided with the distribution.
# * Neither the name of Google Inc. nor the names of its contributors may be
#   used to endorse or promote products derived from this software without
#   specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# Authors: keir@google.com (Keir Mierle)
#          alexs.mac@gmail.com (Alex Stewart)

cmake_minimum_required(VERSION 3.10)

if (POLICY CMP0074) # Added in CMake 3.12
  # FindTBB.cmake uses TBB_ROOT in a way that is historical, but also compliant
  # with CMP0074 so suppress the legacy compatibility warning and allow its use.
  cmake_policy(SET CMP0074 NEW)
endif()

# On macOS, add the Homebrew prefix (with appropriate suffixes) to the
# respective HINTS directories (after any user-specified locations).  This
# handles Homebrew installations into non-standard locations (not /usr/local).
# We do not use CMAKE_PREFIX_PATH for this as given the search ordering of
# find_xxx(), doing so would override any user-specified HINTS locations with
# the Homebrew version if it exists.
if (CMAKE_SYSTEM_NAME MATCHES "Darwin")
  find_program(HOMEBREW_EXECUTABLE brew)
  mark_as_advanced(FORCE HOMEBREW_EXECUTABLE)
  if (HOMEBREW_EXECUTABLE)
    # Detected a Homebrew install, query for its install prefix.
    execute_process(COMMAND ${HOMEBREW_EXECUTABLE} --prefix
      OUTPUT_VARIABLE HOMEBREW_INSTALL_PREFIX
      OUTPUT_STRIP_TRAILING_WHITESPACE)
    message(STATUS "Detected Homebrew with install prefix: "
      "${HOMEBREW_INSTALL_PREFIX}, adding to CMake search paths.")
    list(APPEND CMAKE_PREFIX_PATH "${HOMEBREW_INSTALL_PREFIX}")
  endif()
endif()

project(Ceres C CXX)

# NOTE: The following CMake variables must be applied consistently to all
# targets in project to avoid visibility warnings by placing the variables at
# the project top.

# Always build position-independent code (PIC), even when building Ceres as a
# static library so that shared libraries can link against it, not just
# executables (PIC does not apply on Windows). Global variable can be overridden
# by the user whereas target properties can be not.
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
# Set the default symbol visibility to hidden to unify the behavior among
# the various compilers and to get smaller binaries
set(CMAKE_C_VISIBILITY_PRESET hidden)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN ON)

# NOTE: The 'generic' CMake variables CMAKE_[SOURCE/BINARY]_DIR should not be
#       used.  Always use the project-specific variants (generated by CMake):
#       <PROJECT_NAME_MATCHING_CASE>_[SOURCE/BINARY]_DIR, e.g.
#       Ceres_SOURCE_DIR (note, *not* CERES_SOURCE_DIR) instead, as these will
#       always point to the correct directories for the Ceres project, even if
#       it is nested inside another source tree, whereas the 'generic'
#       CMake variables refer to the *first* project() declaration, i.e. the
#       top-level project, not Ceres, if Ceres is nested.

# Make CMake aware of the cmake folder for local FindXXX scripts,
# append rather than set in case the user has passed their own
# additional paths via -D.
list(APPEND CMAKE_MODULE_PATH "${Ceres_SOURCE_DIR}/cmake")
include(AddCompileFlagsIfSupported)
include(CheckCXXCompilerFlag)
include(CheckLibraryExists)
include(GNUInstallDirs)
include(UpdateCacheVariable)

check_cxx_compiler_flag(/bigobj HAVE_BIGOBJ)
check_library_exists(m pow "" HAVE_LIBM)

# Xcode 11.0-1 with macOS 10.15 (Catalina) broke alignment.
include(DetectBrokenStackCheckMacOSXcodePairing)
detect_broken_stack_check_macos_xcode_pairing()

# Set up the git hook to make Gerrit Change-Id: lines in commit messages.
include(AddGerritCommitHook)
add_gerrit_commit_hook(${Ceres_SOURCE_DIR} ${Ceres_BINARY_DIR})

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${Ceres_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${Ceres_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${Ceres_BINARY_DIR}/lib)
# Set postfixes for generated libraries based on buildtype.
set(CMAKE_RELEASE_POSTFIX "")
set(CMAKE_DEBUG_POSTFIX "-debug")

# Read the Ceres version from the source, such that we only ever have a single
# definition of the Ceres version.
include(ReadCeresVersionFromSource)
read_ceres_version_from_source(${Ceres_SOURCE_DIR})

enable_testing()

include(CeresThreadingModels)
include(PrettyPrintCMakeList)
find_available_ceres_threading_models(CERES_THREADING_MODELS_AVAILABLE)
pretty_print_cmake_list(PRETTY_CERES_THREADING_MODELS_AVAILABLE
  ${CERES_THREADING_MODELS_AVAILABLE})
message("-- Detected available Ceres threading models: "
  "${PRETTY_CERES_THREADING_MODELS_AVAILABLE}")
set(CERES_THREADING_MODEL "${CERES_THREADING_MODEL}" CACHE STRING
  "Ceres threading back-end" FORCE)
if (NOT CERES_THREADING_MODEL)
  list(GET CERES_THREADING_MODELS_AVAILABLE 0 DEFAULT_THREADING_MODEL)
  update_cache_variable(CERES_THREADING_MODEL ${DEFAULT_THREADING_MODEL})
endif()
set_property(CACHE CERES_THREADING_MODEL PROPERTY STRINGS
  ${CERES_THREADING_MODELS_AVAILABLE})

option(MINIGLOG "Use a stripped down version of glog." OFF)
option(GFLAGS "Enable Google Flags." ON)
option(SUITESPARSE "Enable SuiteSparse." ON)
option(CXSPARSE "Enable CXSparse." ON)
if (APPLE)
  option(ACCELERATESPARSE
    "Enable use of sparse solvers in Apple's Accelerate framework." ON)
  option(ENABLE_BITCODE
    "Enable bitcode for iOS builds (disables inline optimizations for Eigen)." OFF)
endif()
option(CUDA "Enable use of CUDA linear algebra solvers." ON)
option(LAPACK "Enable use of LAPACK directly within Ceres." ON)
# Template specializations for the Schur complement based solvers. If
# compile time, binary size or compiler performance is an issue, you
# may consider disabling this.
option(SCHUR_SPECIALIZATIONS "Enable fixed-size schur specializations." ON)
option(CUSTOM_BLAS
       "Use handcoded BLAS routines (usually faster) instead of Eigen."
       ON)
# Enable the use of Eigen as a sparse linear algebra library for
# solving the nonlinear least squares problems.
option(EIGENSPARSE "Enable Eigen as a sparse linear algebra library." ON)
option(EXPORT_BUILD_DIR
  "Export build directory using CMake (enables external use without install)." OFF)
option(BUILD_TESTING "Enable tests" ON)
option(BUILD_DOCUMENTATION "Build User's Guide (html)" OFF)
option(BUILD_EXAMPLES "Build examples" ON)
option(BUILD_BENCHMARKS "Build Ceres benchmarking suite" ON)
option(BUILD_SHARED_LIBS "Build Ceres as a shared library." OFF)
option(PROVIDE_UNINSTALL_TARGET "Add a custom target to ease removal of installed targets" ON)
set(SANITIZERS "" CACHE STRING "Semicolon-separated list of sanitizers to use (e.g address, memory, thread)")
include(EnableSanitizer)
enable_sanitizer(${SANITIZERS})
if (ANDROID)
  option(ANDROID_STRIP_DEBUG_SYMBOLS "Strip debug symbols from Android builds (reduces file sizes)" ON)
endif()
if (MSVC)
  # TODO Not needed starting CMake 3.15 which provides CMAKE_MSVC_RUNTIME_LIBRARY
  option(MSVC_USE_STATIC_CRT
    "MS Visual Studio: Use static C-Run Time Library in place of shared." OFF)
endif()

# IOS is defined iff using the iOS.cmake CMake toolchain to build a static
# library for iOS.
if (IOS)
  message(STATUS "Building Ceres for iOS platform: ${IOS_PLATFORM}")

  # Ceres requires at least iOS 7.0+.
  if (IOS_DEPLOYMENT_TARGET VERSION_LESS 7.0)
    message(FATAL_ERROR "Unsupported iOS version: ${IOS_DEPLOYMENT_TARGET}, Ceres "
      "requires at least iOS version 7.0")
  endif()

  update_cache_variable(MINIGLOG ON)
  message(STATUS "Building for iOS: Forcing use of miniglog instead of glog.")

  # Apple claims that the BLAS call dsyrk_ is a private API, and will not allow
  # you to submit to the Apple Store if the symbol is present.
  update_cache_variable(LAPACK OFF)
  message(STATUS "Building for iOS: SuiteSparse, CXSparse, LAPACK, gflags, "
    "and OpenMP are not available.")

  update_cache_variable(BUILD_EXAMPLES OFF)
  message(STATUS "Building for iOS: Will not build examples.")
endif (IOS)

unset(CERES_COMPILE_OPTIONS)

# Eigen.
# Eigen delivers Eigen3Config.cmake since v3.3.3
find_package(Eigen3 3.3 REQUIRED)
if (Eigen3_FOUND)
  message("-- Found Eigen version ${Eigen3_VERSION}: ${Eigen3_DIR}")
  if (CMAKE_SYSTEM_PROCESSOR MATCHES "^(aarch64.*|AARCH64.*)" AND
      Eigen3_VERSION VERSION_LESS 3.3.4)
    # As per issue #289: https://github.com/ceres-solver/ceres-solver/issues/289
    # the bundle_adjustment_test will fail for Eigen < 3.3.4 on aarch64.
    message(FATAL_ERROR "-- Ceres requires Eigen version >= 3.3.4 on aarch64. "
      "Detected version of Eigen is: ${Eigen3_VERSION}.")
  endif()

  if (EIGENSPARSE)
    message("-- Enabling use of Eigen as a sparse linear algebra library.")
    list(APPEND CERES_COMPILE_OPTIONS CERES_USE_EIGEN_SPARSE)
  else (EIGENSPARSE)
    message("-- Disabling use of Eigen as a sparse linear algebra library.")
    message("   This does not affect the covariance estimation algorithm ")
    message("   which can still use the EIGEN_SPARSE_QR algorithm.")
    add_definitions(-DEIGEN_MPL2_ONLY)
  endif (EIGENSPARSE)
endif (Eigen3_FOUND)

if (CUDA)
  find_package(CUDA QUIET)
  if (CUDA_FOUND)
    message("-- Found CUDA version ${CUDA_VERSION}: "
        "${CUDA_LIBRARIES};"
        "${CUDA_cusolver_LIBRARY};"
        "${CUDA_cusparse_LIBRARY}")
  else (CUDA_FOUND)
    message("-- Did not find CUDA library, disabling CUDA support.")
    update_cache_variable(CUDA OFF)
    list(APPEND CERES_COMPILE_OPTIONS CERES_NO_CUDA)
  endif (CUDA_FOUND)
else (CUDA)
  message("-- Building without CUDA.")
  list(APPEND CERES_COMPILE_OPTIONS CERES_NO_CUDA)
endif (CUDA)

if (LAPACK)
  find_package(LAPACK QUIET)
  if (LAPACK_FOUND)
    message("-- Found LAPACK library: ${LAPACK_LIBRARIES}")
  else (LAPACK_FOUND)
    message("-- Did not find LAPACK library, disabling LAPACK support.")
    update_cache_variable(LAPACK OFF)
    list(APPEND CERES_COMPILE_OPTIONS CERES_NO_LAPACK)
  endif (LAPACK_FOUND)
else (LAPACK)
  message("-- Building without LAPACK.")
  list(APPEND CERES_COMPILE_OPTIONS CERES_NO_LAPACK)
endif (LAPACK)

# Set the install path for the installed CeresConfig.cmake configuration file
# relative to CMAKE_INSTALL_PREFIX.
set(RELATIVE_CMAKECONFIG_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}/cmake/Ceres)

if (SUITESPARSE)
  # By default, if SuiteSparse and all dependencies are found, Ceres is
  # built with SuiteSparse support.

  # Check for SuiteSparse and dependencies.
  find_package(SuiteSparse 4.0 COMPONENTS CHOLMOD SPQR)
  if (SuiteSparse_FOUND)
    set(SuiteSparse_DEPENDENCY "find_dependency(SuiteSparse ${SuiteSparse_VERSION})")
    # By default, if all of SuiteSparse's dependencies are found, Ceres is

=== examples/CMakeLists.txt ===
# Ceres Solver - A fast non-linear least squares minimizer
# Copyright 2022 Google Inc. All rights reserved.
# http://ceres-solver.org/
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright notice,
#   this list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright notice,
#   this list of conditions and the following disclaimer in the documentation
#   and/or other materials provided with the distribution.
# * Neither the name of Google Inc. nor the names of its contributors may be
#   used to endorse or promote products derived from this software without
#   specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# Author: keir@google.com (Keir Mierle)

add_executable(helloworld helloworld.cc)
target_link_libraries(helloworld PRIVATE Ceres::ceres)

add_executable(helloworld_numeric_diff helloworld_numeric_diff.cc)
target_link_libraries(helloworld_numeric_diff PRIVATE Ceres::ceres)

add_executable(helloworld_analytic_diff helloworld_analytic_diff.cc)
target_link_libraries(helloworld_analytic_diff PRIVATE Ceres::ceres)

add_executable(curve_fitting curve_fitting.cc)
target_link_libraries(curve_fitting PRIVATE Ceres::ceres)

add_executable(rosenbrock rosenbrock.cc)
target_link_libraries(rosenbrock PRIVATE Ceres::ceres)

add_executable(rosenbrock_analytic_diff rosenbrock_analytic_diff.cc)
target_link_libraries(rosenbrock_analytic_diff PRIVATE Ceres::ceres)

add_executable(rosenbrock_numeric_diff rosenbrock_numeric_diff.cc)
target_link_libraries(rosenbrock_numeric_diff PRIVATE Ceres::ceres)

add_executable(curve_fitting_c curve_fitting.c)
target_link_libraries(curve_fitting_c PRIVATE Ceres::ceres)
# Force CMake to link curve_fitting_c using the C++ linker.
set_target_properties(curve_fitting_c PROPERTIES LINKER_LANGUAGE CXX)
# As this is a C file #including <math.h> we have to explicitly add the math
# library (libm). Although some compilers (dependent upon options) will accept
# the indirect link to libm via Ceres, at least GCC 4.8 on pure Debian won't.
if (HAVE_LIBM)
  target_link_libraries(curve_fitting_c PRIVATE m)
endif (HAVE_LIBM)

add_executable(ellipse_approximation ellipse_approximation.cc)
target_link_libraries(ellipse_approximation PRIVATE Ceres::ceres)

add_executable(robust_curve_fitting robust_curve_fitting.cc)
target_link_libraries(robust_curve_fitting PRIVATE Ceres::ceres)

add_executable(simple_bundle_adjuster simple_bundle_adjuster.cc)
target_link_libraries(simple_bundle_adjuster PRIVATE Ceres::ceres)

add_executable(bicubic_interpolation bicubic_interpolation.cc)
target_link_libraries(bicubic_interpolation PRIVATE Ceres::ceres)

add_executable(bicubic_interpolation_analytic bicubic_interpolation_analytic.cc)
target_link_libraries(bicubic_interpolation_analytic PRIVATE Ceres::ceres)

if (GFLAGS)
  add_executable(powell powell.cc)
  target_link_libraries(powell PRIVATE Ceres::ceres gflags)

  add_executable(nist nist.cc)
  target_link_libraries(nist PRIVATE Ceres::ceres gflags)
  if (HAVE_BIGOBJ)
    target_compile_options(nist PRIVATE /bigobj)
  endif()

  add_executable(more_garbow_hillstrom more_garbow_hillstrom.cc)
  target_link_libraries(more_garbow_hillstrom PRIVATE Ceres::ceres gflags)

  add_executable(circle_fit circle_fit.cc)
  target_link_libraries(circle_fit PRIVATE Ceres::ceres gflags)

  add_executable(bundle_adjuster
                 bundle_adjuster.cc
                 bal_problem.cc)
  target_link_libraries(bundle_adjuster PRIVATE Ceres::ceres gflags)

  add_executable(libmv_bundle_adjuster
                 libmv_bundle_adjuster.cc)
  target_link_libraries(libmv_bundle_adjuster PRIVATE Ceres::ceres gflags)

  add_executable(libmv_homography
                 libmv_homography.cc)
  target_link_libraries(libmv_homography PRIVATE Ceres::ceres gflags)

  add_executable(denoising
                 denoising.cc
                 fields_of_experts.cc)
  target_link_libraries(denoising PRIVATE Ceres::ceres gflags)

  add_executable(robot_pose_mle
                 robot_pose_mle.cc)
  target_link_libraries(robot_pose_mle PRIVATE Ceres::ceres gflags)
endif (GFLAGS)

add_subdirectory(sampled_function)
add_subdirectory(slam)

## ceres-solver 2.1.0+dfsg

=== debian/changelog ===
ceres-solver (2.1.0+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Update patches for new version
  * Fix Sphinx theme not found
  * Update debian/copyright
  * Remove unused lintian override

 -- Francois Mazen <francois@mzf.fr>  Sun, 10 Apr 2022 00:21:07 +0200

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/default.mk

# If SALSABUILD is set we want to drop debug info as well
ifneq ($(SALSABUILD),)
  export DEB_CXXFLAGS_MAINT_APPEND += -g0
endif

# no debug info to avoid running
# out of address space when linking
ifneq (,$(filter $(DEB_HOST_ARCH), mipsel))
	export DEB_CXXFLAGS_MAINT_APPEND += -g0
endif


# compute current and next Eigen version and add it to d/control
# Needed because CeresConfig.cmake sets it in CERES_EIGEN_VERSION
# also see #868355
eigenvercurr := $(shell dpkg-query -W -f '$${Source:Upstream-Version}' libeigen3-dev | awk -F. '{print $$1"."$$2"."$$3}')
eigenvernext := $(shell dpkg-query -W -f '$${Source:Upstream-Version}' libeigen3-dev | awk -F. '{print $$1"."$$2"."$$3+1}')

build: build-arch build-indep
build-arch: build-process
build-indep: build-process

build-process:
	# Build static library
	dh_testdir
	dh_auto_configure -- \
		-DBUILD_SHARED_LIBS=OFF \
		-DBUILD_EXAMPLES=OFF \
		-DSUITESPARSE_LIBRARY_DIR_HINTS=/usr/lib/${DEB_HOST_MULTIARCH}/ \
		-DSUITESPARSE_INCLUDE_DIR_HINTS=/usr/include/suitesparse/ \
		-DCXSPARSE_LIBRARY_DIR_HINTS=/usr/lib/${DEB_HOST_MULTIARCH}/ \
		-DCXSPARSE_INCLUDE_DIR=/usr/include/suitesparse/ \
		-DBUILD_DOCUMENTATION=OFF \
		-DCMAKE_BUILD_TYPE=Release
	dh_auto_build
	dh_auto_test
	mv -v ${CURDIR}/obj-*/lib/libceres.a ${CURDIR}/debian/
	# Build shared library + documentation
	dh_testdir
	dh_auto_configure -- \
		-DBUILD_SHARED_LIBS=ON \
		-DBUILD_EXAMPLES=OFF \
		-DSUITESPARSE_LIBRARY_DIR_HINTS=/usr/lib/${DEB_HOST_MULTIARCH}/ \
		-DSUITESPARSE_INCLUDE_DIR_HINTS=/usr/include/suitesparse/ \
		-DCXSPARSE_LIBRARY_DIR_HINTS=/usr/lib/${DEB_HOST_MULTIARCH}/ \
		-DCXSPARSE_INCLUDE_DIR=/usr/include/suitesparse/ \
		-DBUILD_DOCUMENTATION=$(if $(filter ceres-solver-doc,$(shell dh_listpackages)),ON,OFF) \
		-DCMAKE_BUILD_TYPE=Release
	dh_auto_build
	dh_auto_test
	# Create build stamp
	touch ${CURDIR}/build-process

%:
	dh $@

override_dh_clean:
	rm -vf ${CURDIR}/build-process ${CURDIR}/debian/libceres.a
	dh_clean

execute_before_dh_gencontrol:
	echo 'eigen:Upstream-Version=$(eigenvercurr)' >> debian/libceres-dev.substvars
	echo 'eigen:Upstream-Version-Next=$(eigenvernext)' >> debian/libceres-dev.substvars

override_dh_compress:
	dh_compress -X.cc -X.h

override_dh_install:
	mkdir -vp ${CURDIR}/debian/libceres-dev/usr/lib ${CURDIR}/debian/libceres-dev/usr/include/ceres/internal
	mv -v ${CURDIR}/debian/libceres.a ${CURDIR}/debian/libceres-dev/usr/lib/
	dh_install

override_dh_installdocs-indep:
	# make lintian happy
	# https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.0 -> /usr/share/javascript/mathjax
	sed -i 's/https:\/\/cdnjs.cloudflare.com\/ajax\/libs\/mathjax\/2.7.1/\/usr\/share\/javascript\/mathjax/g' $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/*.html
	sed -i 's/https:\/\/cdn.jsdelivr.net//g' $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/*.html
	rm $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/_static/doctools.js
	ln -s /usr/share/javascript/sphinxdoc/1.0/doctools.js $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/_static/doctools.js
	rm $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/_static/jquery.js
	ln -s /usr/share/javascript/jquery/jquery.js $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/_static/jquery.js
	rm -f $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/_static/js/html5shiv-printshiv.min.js
	ln -s /usr/share/javascript/html5shiv/html5shiv-printshiv.min.js $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/_static/js/html5shiv-printshiv.min.js
	rm -f $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/_static/js/html5shiv.min.js
	ln -s /usr/share/javascript/html5shiv/html5shiv.min.js $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/_static/js/html5shiv.min.js
	rm -f $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/_static/language_data.js
	ln -s /usr/share/javascript/sphinxdoc/1.0/language_data.js $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/_static/language_data.js
	rm -f $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/_static/searchtools.js
	ln -s /usr/share/javascript/sphinxdoc/1.0/searchtools.js $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/_static/searchtools.js
	rm -f $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/_static/underscore.js
	ln -s /usr/share/javascript/underscore/underscore.js $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/_static/underscore.js
	rm -rf $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/_static/fonts
	ln -s /usr/share/fonts/truetype/lato $(CURDIR)/debian/tmp/usr/share/doc/Ceres/html/_static/fonts
	dh_installdocs


.PHONY: build

## ceres-solver 2.1.0+really2.0.0+dfsg1

=== debian/changelog ===
ceres-solver (2.1.0+really2.0.0+dfsg1-2) unstable; urgency=medium

  * Team upload
  * Explicitly requiring to build the tests with the shared lib
  * Removing duplicate line in d/copyright

 -- Pierre Gruet <pgt@debian.org>  Tue, 07 Jun 2022 15:22:34 +0200

ceres-solver (2.1.0+really2.0.0+dfsg1-1) unstable; urgency=medium

  * Team upload
  * New upstream version 2.1.0+really2.0.0+dfsg1 (Closes: #1012419)
  * Refreshing patches
  * Back to former install and docs paths
  * Fixing unneeded versioned dependencies in d/control
  * Building and running the tests only when building the shared library,
    so that they are not run twice.
  * Honouring DEB_BUILD_OPTIONS=nocheck

  [ Francois Mazen ]
  * Bump standard version to 4.6.1.0
  * Add Multi-Arch fields in debian/control
  * Update copyright date
  * Adding a patch to fix i386 failing tests with version 2.1.0+dfsg

 -- Pierre Gruet <pgt@debian.org>  Tue, 07 Jun 2022 14:04:12 +0200

=== debian/control ===
Source: ceres-solver
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>,
           Francois Mazen <francois@mzf.fr>
Section: math
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               libatlas-base-dev,
               libgoogle-glog-dev,
               libgflags-dev,
               libeigen3-dev,
               libsuitesparse-dev,
               gawk | awk
Build-Depends-Indep: python3:any,
                     python3-sphinx-rtd-theme:native,
                     libjs-jquery,
                     libjs-mathjax,
                     libjs-modernizr,
                     libjs-underscore,
                     libjs-sphinxdoc,
                     node-html5shiv,
Standards-Version: 4.6.1.0
Vcs-Browser: https://salsa.debian.org/science-team/ceres-solver
Vcs-Git: https://salsa.debian.org/science-team/ceres-solver.git
Homepage: http://ceres-solver.org
Rules-Requires-Root: no

Package: libceres-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libceres2 (= ${binary:Version}),
         ${misc:Depends},
         libgoogle-glog-dev,
         libgflags-dev,
         libeigen3-dev (>= ${eigen:Upstream-Version}),
         libeigen3-dev (<< ${eigen:Upstream-Version-Next}),
         libsuitesparse-dev
Description: nonlinear least squares minimizer (development files)
 Ceres Solver is an open source C++ library for modeling and solving large,
 complicated optimization problems.
 It is a feature rich, mature and performant library which has been used
 in production at Google since 2010.
 .
 Ceres Solver can solve two kinds of problems.
  - Non-linear Least Squares problems with bounds constraints.
  - General unconstrained optimization problems.
 .
 This package contains the development header files.

Package: libceres2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: nonlinear least squares minimizer (shared library)
 Ceres Solver is an open source C++ library for modeling and solving large,
 complicated optimization problems.
 It is a feature rich, mature and performant library which has been used
 in production at Google since 2010.
 .
 Ceres Solver can solve two kinds of problems.
  - Non-linear Least Squares problems with bounds constraints.
  - General unconstrained optimization problems.
 .
 This package contains the shared library.

Package: ceres-solver-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         libjs-mathjax,
         libjs-jquery,
         libjs-modernizr,
         libjs-underscore,
         libjs-sphinxdoc,
         node-html5shiv,
         fonts-lato
Description: documentation for ceres-solver
 Ceres Solver is an open source C++ library for modeling and solving large,
 complicated optimization problems.
 It is a feature rich, mature and performant library which has been used
 in production at Google since 2010.
 .
 Ceres Solver can solve two kinds of problems.
  - Non-linear Least Squares problems with bounds constraints.
  - General unconstrained optimization problems.
 .
 This package contains the documentation found on http://ceres-solver.org/
 and the examples that were included with the release.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/default.mk

# If SALSABUILD is set we want to drop debug info as well
ifneq ($(SALSABUILD),)
  export DEB_CXXFLAGS_MAINT_APPEND += -g0
endif

# no debug info to avoid running
# out of address space when linking
ifneq (,$(filter $(DEB_HOST_ARCH), mipsel))
	export DEB_CXXFLAGS_MAINT_APPEND += -g0
endif


# compute current and next Eigen version and add it to d/control
# Needed because CeresConfig.cmake sets it in CERES_EIGEN_VERSION
# also see #868355
eigenvercurr := $(shell dpkg-query -W -f '$${Source:Upstream-Version}' libeigen3-dev | awk -F. '{print $$1"."$$2"."$$3}')
eigenvernext := $(shell dpkg-query -W -f '$${Source:Upstream-Version}' libeigen3-dev | awk -F. '{print $$1"."$$2"."$$3+1}')

build: build-arch build-indep
build-arch: build-process
build-indep: build-process

build-process:
	# Build static library
	dh_testdir
	dh_auto_configure -- \
		-DBUILD_SHARED_LIBS=OFF \
		-DBUILD_EXAMPLES=OFF \
		-DBUILD_TESTING=OFF \
		-DSUITESPARSE_LIBRARY_DIR_HINTS=/usr/lib/${DEB_HOST_MULTIARCH}/ \
		-DSUITESPARSE_INCLUDE_DIR_HINTS=/usr/include/suitesparse/ \
		-DCXSPARSE_LIBRARY_DIR_HINTS=/usr/lib/${DEB_HOST_MULTIARCH}/ \
		-DCXSPARSE_INCLUDE_DIR=/usr/include/suitesparse/ \
		-DBUILD_DOCUMENTATION=OFF \
		-DCMAKE_BUILD_TYPE=Release
	dh_auto_build
	mv -v ${CURDIR}/obj-*/lib/libceres.a ${CURDIR}/debian/
	mv -v ${CURDIR}/obj-*/config/ceres/internal/config.h ${CURDIR}/debian/
	# Build shared library + documentation
	dh_testdir
	dh_auto_configure -- \
		-DBUILD_SHARED_LIBS=ON \
		-DBUILD_EXAMPLES=OFF \
		-DBUILD_TESTING=ON \
		-DSUITESPARSE_LIBRARY_DIR_HINTS=/usr/lib/${DEB_HOST_MULTIARCH}/ \
		-DSUITESPARSE_INCLUDE_DIR_HINTS=/usr/include/suitesparse/ \
		-DCXSPARSE_LIBRARY_DIR_HINTS=/usr/lib/${DEB_HOST_MULTIARCH}/ \
		-DCXSPARSE_INCLUDE_DIR=/usr/include/suitesparse/ \
		-DBUILD_DOCUMENTATION=$(if $(filter ceres-solver-doc,$(shell dh_listpackages)),ON,OFF) \
		-DCMAKE_BUILD_TYPE=Release
	dh_auto_build
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test
endif
	# Create build stamp
	touch ${CURDIR}/build-process

%:
	dh $@

override_dh_clean:
	rm -vf ${CURDIR}/build-process ${CURDIR}/debian/libceres.a
	dh_clean

execute_before_dh_gencontrol:
	echo 'eigen:Upstream-Version=$(eigenvercurr)' >> debian/libceres-dev.substvars
	echo 'eigen:Upstream-Version-Next=$(eigenvernext)' >> debian/libceres-dev.substvars

override_dh_compress:
	dh_compress -X.cc -X.h

override_dh_install:
	mkdir -vp ${CURDIR}/debian/libceres-dev/usr/lib ${CURDIR}/debian/libceres-dev/usr/include/ceres/internal
	mv -v ${CURDIR}/debian/libceres.a ${CURDIR}/debian/libceres-dev/usr/lib/
	mv -v ${CURDIR}/debian/config.h ${CURDIR}/debian/libceres-dev/usr/include/ceres/internal/
	dh_install

override_dh_installdocs-indep:
	# make lintian happy
	# https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.0 -> /usr/share/javascript/mathjax
	sed -i 's/https:\/\/cdnjs.cloudflare.com\/ajax\/libs\/mathjax\/2.7.1/\/usr\/share\/javascript\/mathjax/g' $(CURDIR)/debian/tmp/usr/share/doc/ceres/html/*.html
	sed -i 's/https:\/\/cdn.jsdelivr.net//g' $(CURDIR)/debian/tmp/usr/share/doc/ceres/html/*.html
	rm debian/tmp/usr/share/doc/ceres/html/_static/doctools.js
	ln -s /usr/share/javascript/sphinxdoc/1.0/doctools.js debian/tmp/usr/share/doc/ceres/html/_static/doctools.js
	rm debian/tmp/usr/share/doc/ceres/html/_static/jquery.js
	ln -s /usr/share/javascript/jquery/jquery.js debian/tmp/usr/share/doc/ceres/html/_static/jquery.js
	rm -f debian/tmp/usr/share/doc/ceres/html/_static/js/html5shiv-printshiv.min.js
	ln -s /usr/share/javascript/html5shiv/html5shiv-printshiv.min.js debian/tmp/usr/share/doc/ceres/html/_static/js/html5shiv-printshiv.min.js
	rm -f debian/tmp/usr/share/doc/ceres/html/_static/js/html5shiv.min.js
	ln -s /usr/share/javascript/html5shiv/html5shiv.min.js debian/tmp/usr/share/doc/ceres/html/_static/js/html5shiv.min.js
	rm -f debian/tmp/usr/share/doc/ceres/html/_static/language_data.js
	ln -s /usr/share/javascript/sphinxdoc/1.0/language_data.js debian/tmp/usr/share/doc/ceres/html/_static/language_data.js
	rm -f debian/tmp/usr/share/doc/ceres/html/_static/searchtools.js
	ln -s /usr/share/javascript/sphinxdoc/1.0/searchtools.js debian/tmp/usr/share/doc/ceres/html/_static/searchtools.js
	rm -f debian/tmp/usr/share/doc/ceres/html/_static/underscore.js
	ln -s /usr/share/javascript/underscore/underscore.js debian/tmp/usr/share/doc/ceres/html/_static/underscore.js
	rm -rf debian/tmp/usr/share/doc/ceres/html/_static/fonts
	ln -s /usr/share/fonts/truetype/lato debian/tmp/usr/share/doc/ceres/html/_static/fonts
	dh_installdocs


.PHONY: build
